#include<stdio.h>

//pomocna funkcija: je li broj n prost
int prost(int n){
    if(n <= 1)
        return 0;
    int i;
    for(i = 2; i < n; ++i)
        if(n % i == 0)
            return 0;
    return 1;
}

/*
Argumenti funkcije:
  n     = uk. broj kilometara ceste D2021
  k     = preostali br. panoa za postavljanje
  poslj = kilometar gdje je posljednji trenutno postavljeni pano
  udalj = udaljenost od posljednje postavljenog panoa
*/

int br_nacina(int n, int k, int poslj, int udalj){
    if(k == 0){ //sve panoe postavili
        //provjeri je li posljednji pano gdje treba biti
        if(poslj <= n && poslj >= n - 4)
            return 1;
        return 0;
    }

    //inace postavimo sljedeci pano na i-ti kilometar
    int i, br = 0;
    for(i = poslj + udalj; i <= n; ++i)
        if(prost(i) == 0)
            br += br_nacina(n, k - 1, i, i - poslj);

    return br;
}

int main(int argc, char* argv[]){
    if(argc != 3){
        printf("GRESKA: Komandna linija nema tocno 2 ulazna parametra!");
        return 2021;
    }

    int n, k, i;
    sscanf(argv[1],"%d",&n);
    sscanf(argv[2],"%d",&k);

    //objasnjenje za poziv funkcije:
    //treba odrediti polozaj ki-1 panoa, jer za prvi
    //pano znamo da mora biti na 0. kilometru,
    //te udalj. mora min. biti 4 km (pa sljedeci pano
    //ide na 4. km ili 5. km ili 6. km ili ...)
    printf("Ispis svih k' koji zadovoljavaju uvjet:\n");
    for(i = 2; i <= k; ++i)
        if(prost(br_nacina(n,i-1,0,4)) == 1)
            printf("%d\n",i);

    return 0;
}
