#include<stdio.h>

//pomocna funkcija: je li broj n prost
int prost(int n){
    if(n <= 1)
        return 0;
    int i;
    for(i = 2; i < n; ++i)
        if(n % i == 0)
            return 0;
    return 1;
}

/*
Argumenti funkcije:
  n     = uk. broj standova
  k     = preostali iznos dolara za trosenje
  p_kol = koliko kupili na poslj. standu
  p_br  = posljednji stand na kojem kupovali
*/

int br_nacina(int n, int k, int p_kol, int p_br){
    if(k < 9){ //ne mogu vise kupiti niti jedan rakburger
        //provjeri je li posljednji stand zadnji (ili predzadnji)
        if(p_br == n || (p_br == n - 1 && n > 1))
            return 1;
        return 0;
    }

    //inace kupimo j burgera na i-tom standu
    int i, j, br = 0;
    for(i = p_br + 1; i <= n; ++i)
        for(j = p_kol + 1; j <= k/9; ++j)
          if(prost(i) == 0)
            br += br_nacina(n, k-j*9, j, i);

    return br;
}

int main(int argc, char* argv[]){
    if(argc != 3){
        printf("GRESKA: Komandna linija nema tocno 2 ulazna parametra!");
        return 5;
    }

    int n, m, k;
    sscanf(argv[1],"%d",&n);
    sscanf(argv[2],"%d",&m);

    printf("%d\n",br_nacina(n,m,0,0));

    //objasnjenje za poziv funkcije:
    //ukupno je n standova, te je k dolara za trositi
    //prethodno pojeli 0 rakburgera (pa u fji ide od 1 nadalje)
    //te ,,bili na 0. standu'' (pa u fji ide od 1 nadalje)
    printf("Ispis svih k' koji zadovoljavaju uvjet:\n");
    for(k = 1; k <= m; ++k)
        if(prost(br_nacina(n,k,0,0)) == 0
           && br_nacina(n,k,0,0) != 0)
            printf("%d\n",k);

    return 0;
}
